=begin
#Pulp 3 API

#Fetch, Upload, Organize, and Distribute Software Packages

The version of the OpenAPI document: v3
Contact: pulp-list@redhat.com
Generated by: https://openapi-generator.tech
OpenAPI Generator version: 4.3.1

=end

require 'cgi'

module PulpContainerClient
  class RepositoriesContainerApi
    attr_accessor :api_client

    def initialize(api_client = ApiClient.default)
      @api_client = api_client
    end
    # Add content
    # Trigger an asynchronous task to recursively add container content.
    # @param container_container_repository_href [String] 
    # @param recursive_manage [RecursiveManage] 
    # @param [Hash] opts the optional parameters
    # @return [AsyncOperationResponse]
    def add(container_container_repository_href, recursive_manage, opts = {})
      data, _status_code, _headers = add_with_http_info(container_container_repository_href, recursive_manage, opts)
      data
    end

    # Add content
    # Trigger an asynchronous task to recursively add container content.
    # @param container_container_repository_href [String] 
    # @param recursive_manage [RecursiveManage] 
    # @param [Hash] opts the optional parameters
    # @return [Array<(AsyncOperationResponse, Integer, Hash)>] AsyncOperationResponse data, response status code and response headers
    def add_with_http_info(container_container_repository_href, recursive_manage, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: RepositoriesContainerApi.add ...'
      end
      # verify the required parameter 'container_container_repository_href' is set
      if @api_client.config.client_side_validation && container_container_repository_href.nil?
        fail ArgumentError, "Missing the required parameter 'container_container_repository_href' when calling RepositoriesContainerApi.add"
      end
      # verify the required parameter 'recursive_manage' is set
      if @api_client.config.client_side_validation && recursive_manage.nil?
        fail ArgumentError, "Missing the required parameter 'recursive_manage' when calling RepositoriesContainerApi.add"
      end
      # resource path
      local_var_path = '{container_container_repository_href}add/'.sub('{' + 'container_container_repository_href' + '}', CGI.escape(container_container_repository_href.to_s).gsub('%2F', '/'))

      # query parameters
      query_params = opts[:query_params] || {}

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json', 'application/x-www-form-urlencoded', 'multipart/form-data'])

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:body] || @api_client.object_to_http_body(recursive_manage) 

      # return_type
      return_type = opts[:return_type] || 'AsyncOperationResponse' 

      # auth_names
      auth_names = opts[:auth_names] || ['basicAuth']

      new_options = opts.merge(
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:POST, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: RepositoriesContainerApi#add\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # Build an Image
    # Trigger an asynchronous task to build an OCI image from a Containerfile. A new repository version is created with the new image and tag. This API is tech preview in Pulp Container 1.1. Backwards compatibility when upgrading is not guaranteed.
    # @param container_container_repository_href [String] 
    # @param [Hash] opts the optional parameters
    # @option opts [String] :containerfile_artifact Artifact representing the Containerfile that should be used to run buildah.
    # @option opts [File] :containerfile An uploaded Containerfile that should be used to run buildah.
    # @option opts [String] :tag A tag name for the new image being built. (default to 'latest')
    # @option opts [Object] :artifacts A JSON string where each key is an artifact href and the value is it&#39;s relative path (name) inside the /pulp_working_directory of the build container executing the Containerfile.
    # @return [AsyncOperationResponse]
    def build_image(container_container_repository_href, opts = {})
      data, _status_code, _headers = build_image_with_http_info(container_container_repository_href, opts)
      data
    end

    # Build an Image
    # Trigger an asynchronous task to build an OCI image from a Containerfile. A new repository version is created with the new image and tag. This API is tech preview in Pulp Container 1.1. Backwards compatibility when upgrading is not guaranteed.
    # @param container_container_repository_href [String] 
    # @param [Hash] opts the optional parameters
    # @option opts [String] :containerfile_artifact Artifact representing the Containerfile that should be used to run buildah.
    # @option opts [File] :containerfile An uploaded Containerfile that should be used to run buildah.
    # @option opts [String] :tag A tag name for the new image being built.
    # @option opts [Object] :artifacts A JSON string where each key is an artifact href and the value is it&#39;s relative path (name) inside the /pulp_working_directory of the build container executing the Containerfile.
    # @return [Array<(AsyncOperationResponse, Integer, Hash)>] AsyncOperationResponse data, response status code and response headers
    def build_image_with_http_info(container_container_repository_href, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: RepositoriesContainerApi.build_image ...'
      end
      # verify the required parameter 'container_container_repository_href' is set
      if @api_client.config.client_side_validation && container_container_repository_href.nil?
        fail ArgumentError, "Missing the required parameter 'container_container_repository_href' when calling RepositoriesContainerApi.build_image"
      end
      # resource path
      local_var_path = '{container_container_repository_href}build_image/'.sub('{' + 'container_container_repository_href' + '}', CGI.escape(container_container_repository_href.to_s).gsub('%2F', '/'))

      # query parameters
      query_params = opts[:query_params] || {}

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['multipart/form-data', 'application/x-www-form-urlencoded'])

      # form parameters
      form_params = opts[:form_params] || {}
      form_params['containerfile_artifact'] = opts[:'containerfile_artifact'] if !opts[:'containerfile_artifact'].nil?
      form_params['containerfile'] = opts[:'containerfile'] if !opts[:'containerfile'].nil?
      form_params['tag'] = opts[:'tag'] if !opts[:'tag'].nil?
      form_params['artifacts'] = opts[:'artifacts'] if !opts[:'artifacts'].nil?

      # http body (model)
      post_body = opts[:body] 

      # return_type
      return_type = opts[:return_type] || 'AsyncOperationResponse' 

      # auth_names
      auth_names = opts[:auth_names] || ['basicAuth']

      new_options = opts.merge(
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:POST, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: RepositoriesContainerApi#build_image\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # Copy manifests
    # Trigger an asynchronous task to copy manifests
    # @param container_container_repository_href [String] 
    # @param manifest_copy [ManifestCopy] 
    # @param [Hash] opts the optional parameters
    # @return [AsyncOperationResponse]
    def copy_manifests(container_container_repository_href, manifest_copy, opts = {})
      data, _status_code, _headers = copy_manifests_with_http_info(container_container_repository_href, manifest_copy, opts)
      data
    end

    # Copy manifests
    # Trigger an asynchronous task to copy manifests
    # @param container_container_repository_href [String] 
    # @param manifest_copy [ManifestCopy] 
    # @param [Hash] opts the optional parameters
    # @return [Array<(AsyncOperationResponse, Integer, Hash)>] AsyncOperationResponse data, response status code and response headers
    def copy_manifests_with_http_info(container_container_repository_href, manifest_copy, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: RepositoriesContainerApi.copy_manifests ...'
      end
      # verify the required parameter 'container_container_repository_href' is set
      if @api_client.config.client_side_validation && container_container_repository_href.nil?
        fail ArgumentError, "Missing the required parameter 'container_container_repository_href' when calling RepositoriesContainerApi.copy_manifests"
      end
      # verify the required parameter 'manifest_copy' is set
      if @api_client.config.client_side_validation && manifest_copy.nil?
        fail ArgumentError, "Missing the required parameter 'manifest_copy' when calling RepositoriesContainerApi.copy_manifests"
      end
      # resource path
      local_var_path = '{container_container_repository_href}copy_manifests/'.sub('{' + 'container_container_repository_href' + '}', CGI.escape(container_container_repository_href.to_s).gsub('%2F', '/'))

      # query parameters
      query_params = opts[:query_params] || {}

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json', 'application/x-www-form-urlencoded', 'multipart/form-data'])

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:body] || @api_client.object_to_http_body(manifest_copy) 

      # return_type
      return_type = opts[:return_type] || 'AsyncOperationResponse' 

      # auth_names
      auth_names = opts[:auth_names] || ['basicAuth']

      new_options = opts.merge(
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:POST, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: RepositoriesContainerApi#copy_manifests\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # Copy tags
    # Trigger an asynchronous task to copy tags
    # @param container_container_repository_href [String] 
    # @param tag_copy [TagCopy] 
    # @param [Hash] opts the optional parameters
    # @return [AsyncOperationResponse]
    def copy_tags(container_container_repository_href, tag_copy, opts = {})
      data, _status_code, _headers = copy_tags_with_http_info(container_container_repository_href, tag_copy, opts)
      data
    end

    # Copy tags
    # Trigger an asynchronous task to copy tags
    # @param container_container_repository_href [String] 
    # @param tag_copy [TagCopy] 
    # @param [Hash] opts the optional parameters
    # @return [Array<(AsyncOperationResponse, Integer, Hash)>] AsyncOperationResponse data, response status code and response headers
    def copy_tags_with_http_info(container_container_repository_href, tag_copy, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: RepositoriesContainerApi.copy_tags ...'
      end
      # verify the required parameter 'container_container_repository_href' is set
      if @api_client.config.client_side_validation && container_container_repository_href.nil?
        fail ArgumentError, "Missing the required parameter 'container_container_repository_href' when calling RepositoriesContainerApi.copy_tags"
      end
      # verify the required parameter 'tag_copy' is set
      if @api_client.config.client_side_validation && tag_copy.nil?
        fail ArgumentError, "Missing the required parameter 'tag_copy' when calling RepositoriesContainerApi.copy_tags"
      end
      # resource path
      local_var_path = '{container_container_repository_href}copy_tags/'.sub('{' + 'container_container_repository_href' + '}', CGI.escape(container_container_repository_href.to_s).gsub('%2F', '/'))

      # query parameters
      query_params = opts[:query_params] || {}

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json', 'application/x-www-form-urlencoded', 'multipart/form-data'])

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:body] || @api_client.object_to_http_body(tag_copy) 

      # return_type
      return_type = opts[:return_type] || 'AsyncOperationResponse' 

      # auth_names
      auth_names = opts[:auth_names] || ['basicAuth']

      new_options = opts.merge(
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:POST, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: RepositoriesContainerApi#copy_tags\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # Create a container repository
    # ViewSet for container repo.
    # @param container_container_repository [ContainerContainerRepository] 
    # @param [Hash] opts the optional parameters
    # @return [ContainerContainerRepositoryResponse]
    def create(container_container_repository, opts = {})
      data, _status_code, _headers = create_with_http_info(container_container_repository, opts)
      data
    end

    # Create a container repository
    # ViewSet for container repo.
    # @param container_container_repository [ContainerContainerRepository] 
    # @param [Hash] opts the optional parameters
    # @return [Array<(ContainerContainerRepositoryResponse, Integer, Hash)>] ContainerContainerRepositoryResponse data, response status code and response headers
    def create_with_http_info(container_container_repository, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: RepositoriesContainerApi.create ...'
      end
      # verify the required parameter 'container_container_repository' is set
      if @api_client.config.client_side_validation && container_container_repository.nil?
        fail ArgumentError, "Missing the required parameter 'container_container_repository' when calling RepositoriesContainerApi.create"
      end
      # resource path
      local_var_path = '/pulp/api/v3/repositories/container/container/'

      # query parameters
      query_params = opts[:query_params] || {}

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json', 'application/x-www-form-urlencoded', 'multipart/form-data'])

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:body] || @api_client.object_to_http_body(container_container_repository) 

      # return_type
      return_type = opts[:return_type] || 'ContainerContainerRepositoryResponse' 

      # auth_names
      auth_names = opts[:auth_names] || ['basicAuth']

      new_options = opts.merge(
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:POST, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: RepositoriesContainerApi#create\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # Delete a container repository
    # Trigger an asynchronous delete task
    # @param container_container_repository_href [String] 
    # @param [Hash] opts the optional parameters
    # @return [AsyncOperationResponse]
    def delete(container_container_repository_href, opts = {})
      data, _status_code, _headers = delete_with_http_info(container_container_repository_href, opts)
      data
    end

    # Delete a container repository
    # Trigger an asynchronous delete task
    # @param container_container_repository_href [String] 
    # @param [Hash] opts the optional parameters
    # @return [Array<(AsyncOperationResponse, Integer, Hash)>] AsyncOperationResponse data, response status code and response headers
    def delete_with_http_info(container_container_repository_href, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: RepositoriesContainerApi.delete ...'
      end
      # verify the required parameter 'container_container_repository_href' is set
      if @api_client.config.client_side_validation && container_container_repository_href.nil?
        fail ArgumentError, "Missing the required parameter 'container_container_repository_href' when calling RepositoriesContainerApi.delete"
      end
      # resource path
      local_var_path = '{container_container_repository_href}'.sub('{' + 'container_container_repository_href' + '}', CGI.escape(container_container_repository_href.to_s).gsub('%2F', '/'))

      # query parameters
      query_params = opts[:query_params] || {}

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:body] 

      # return_type
      return_type = opts[:return_type] || 'AsyncOperationResponse' 

      # auth_names
      auth_names = opts[:auth_names] || ['basicAuth']

      new_options = opts.merge(
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:DELETE, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: RepositoriesContainerApi#delete\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # List container repositorys
    # ViewSet for container repo.
    # @param [Hash] opts the optional parameters
    # @option opts [Integer] :limit Number of results to return per page.
    # @option opts [String] :name 
    # @option opts [String] :name__contains Filter results where name contains value
    # @option opts [String] :name__icontains Filter results where name contains value
    # @option opts [Array<String>] :name__in Filter results where name is in a comma-separated list of values
    # @option opts [String] :name__startswith Filter results where name starts with value
    # @option opts [Integer] :offset The initial index from which to return the results.
    # @option opts [String] :ordering Which field to use when ordering the results.
    # @option opts [String] :pulp_label_select Filter labels by search string
    # @option opts [String] :fields A list of fields to include in the response.
    # @option opts [String] :exclude_fields A list of fields to exclude from the response.
    # @return [PaginatedcontainerContainerRepositoryResponseList]
    def list(opts = {})
      data, _status_code, _headers = list_with_http_info(opts)
      data
    end

    # List container repositorys
    # ViewSet for container repo.
    # @param [Hash] opts the optional parameters
    # @option opts [Integer] :limit Number of results to return per page.
    # @option opts [String] :name 
    # @option opts [String] :name__contains Filter results where name contains value
    # @option opts [String] :name__icontains Filter results where name contains value
    # @option opts [Array<String>] :name__in Filter results where name is in a comma-separated list of values
    # @option opts [String] :name__startswith Filter results where name starts with value
    # @option opts [Integer] :offset The initial index from which to return the results.
    # @option opts [String] :ordering Which field to use when ordering the results.
    # @option opts [String] :pulp_label_select Filter labels by search string
    # @option opts [String] :fields A list of fields to include in the response.
    # @option opts [String] :exclude_fields A list of fields to exclude from the response.
    # @return [Array<(PaginatedcontainerContainerRepositoryResponseList, Integer, Hash)>] PaginatedcontainerContainerRepositoryResponseList data, response status code and response headers
    def list_with_http_info(opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: RepositoriesContainerApi.list ...'
      end
      # resource path
      local_var_path = '/pulp/api/v3/repositories/container/container/'

      # query parameters
      query_params = opts[:query_params] || {}
      query_params[:'limit'] = opts[:'limit'] if !opts[:'limit'].nil?
      query_params[:'name'] = opts[:'name'] if !opts[:'name'].nil?
      query_params[:'name__contains'] = opts[:'name__contains'] if !opts[:'name__contains'].nil?
      query_params[:'name__icontains'] = opts[:'name__icontains'] if !opts[:'name__icontains'].nil?
      query_params[:'name__in'] = @api_client.build_collection_param(opts[:'name__in'], :csv) if !opts[:'name__in'].nil?
      query_params[:'name__startswith'] = opts[:'name__startswith'] if !opts[:'name__startswith'].nil?
      query_params[:'offset'] = opts[:'offset'] if !opts[:'offset'].nil?
      query_params[:'ordering'] = opts[:'ordering'] if !opts[:'ordering'].nil?
      query_params[:'pulp_label_select'] = opts[:'pulp_label_select'] if !opts[:'pulp_label_select'].nil?
      query_params[:'fields'] = opts[:'fields'] if !opts[:'fields'].nil?
      query_params[:'exclude_fields'] = opts[:'exclude_fields'] if !opts[:'exclude_fields'].nil?

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:body] 

      # return_type
      return_type = opts[:return_type] || 'PaginatedcontainerContainerRepositoryResponseList' 

      # auth_names
      auth_names = opts[:auth_names] || ['basicAuth']

      new_options = opts.merge(
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:GET, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: RepositoriesContainerApi#list\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # Update a container repository
    # Trigger an asynchronous partial update task
    # @param container_container_repository_href [String] 
    # @param patchedcontainer_container_repository [PatchedcontainerContainerRepository] 
    # @param [Hash] opts the optional parameters
    # @return [AsyncOperationResponse]
    def partial_update(container_container_repository_href, patchedcontainer_container_repository, opts = {})
      data, _status_code, _headers = partial_update_with_http_info(container_container_repository_href, patchedcontainer_container_repository, opts)
      data
    end

    # Update a container repository
    # Trigger an asynchronous partial update task
    # @param container_container_repository_href [String] 
    # @param patchedcontainer_container_repository [PatchedcontainerContainerRepository] 
    # @param [Hash] opts the optional parameters
    # @return [Array<(AsyncOperationResponse, Integer, Hash)>] AsyncOperationResponse data, response status code and response headers
    def partial_update_with_http_info(container_container_repository_href, patchedcontainer_container_repository, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: RepositoriesContainerApi.partial_update ...'
      end
      # verify the required parameter 'container_container_repository_href' is set
      if @api_client.config.client_side_validation && container_container_repository_href.nil?
        fail ArgumentError, "Missing the required parameter 'container_container_repository_href' when calling RepositoriesContainerApi.partial_update"
      end
      # verify the required parameter 'patchedcontainer_container_repository' is set
      if @api_client.config.client_side_validation && patchedcontainer_container_repository.nil?
        fail ArgumentError, "Missing the required parameter 'patchedcontainer_container_repository' when calling RepositoriesContainerApi.partial_update"
      end
      # resource path
      local_var_path = '{container_container_repository_href}'.sub('{' + 'container_container_repository_href' + '}', CGI.escape(container_container_repository_href.to_s).gsub('%2F', '/'))

      # query parameters
      query_params = opts[:query_params] || {}

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json', 'application/x-www-form-urlencoded', 'multipart/form-data'])

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:body] || @api_client.object_to_http_body(patchedcontainer_container_repository) 

      # return_type
      return_type = opts[:return_type] || 'AsyncOperationResponse' 

      # auth_names
      auth_names = opts[:auth_names] || ['basicAuth']

      new_options = opts.merge(
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:PATCH, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: RepositoriesContainerApi#partial_update\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # Inspect a container repository
    # ViewSet for container repo.
    # @param container_container_repository_href [String] 
    # @param [Hash] opts the optional parameters
    # @option opts [String] :fields A list of fields to include in the response.
    # @option opts [String] :exclude_fields A list of fields to exclude from the response.
    # @return [ContainerContainerRepositoryResponse]
    def read(container_container_repository_href, opts = {})
      data, _status_code, _headers = read_with_http_info(container_container_repository_href, opts)
      data
    end

    # Inspect a container repository
    # ViewSet for container repo.
    # @param container_container_repository_href [String] 
    # @param [Hash] opts the optional parameters
    # @option opts [String] :fields A list of fields to include in the response.
    # @option opts [String] :exclude_fields A list of fields to exclude from the response.
    # @return [Array<(ContainerContainerRepositoryResponse, Integer, Hash)>] ContainerContainerRepositoryResponse data, response status code and response headers
    def read_with_http_info(container_container_repository_href, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: RepositoriesContainerApi.read ...'
      end
      # verify the required parameter 'container_container_repository_href' is set
      if @api_client.config.client_side_validation && container_container_repository_href.nil?
        fail ArgumentError, "Missing the required parameter 'container_container_repository_href' when calling RepositoriesContainerApi.read"
      end
      # resource path
      local_var_path = '{container_container_repository_href}'.sub('{' + 'container_container_repository_href' + '}', CGI.escape(container_container_repository_href.to_s).gsub('%2F', '/'))

      # query parameters
      query_params = opts[:query_params] || {}
      query_params[:'fields'] = opts[:'fields'] if !opts[:'fields'].nil?
      query_params[:'exclude_fields'] = opts[:'exclude_fields'] if !opts[:'exclude_fields'].nil?

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:body] 

      # return_type
      return_type = opts[:return_type] || 'ContainerContainerRepositoryResponse' 

      # auth_names
      auth_names = opts[:auth_names] || ['basicAuth']

      new_options = opts.merge(
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:GET, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: RepositoriesContainerApi#read\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # Remove content
    # Trigger an async task to recursively remove container content.
    # @param container_container_repository_href [String] 
    # @param recursive_manage [RecursiveManage] 
    # @param [Hash] opts the optional parameters
    # @return [AsyncOperationResponse]
    def remove(container_container_repository_href, recursive_manage, opts = {})
      data, _status_code, _headers = remove_with_http_info(container_container_repository_href, recursive_manage, opts)
      data
    end

    # Remove content
    # Trigger an async task to recursively remove container content.
    # @param container_container_repository_href [String] 
    # @param recursive_manage [RecursiveManage] 
    # @param [Hash] opts the optional parameters
    # @return [Array<(AsyncOperationResponse, Integer, Hash)>] AsyncOperationResponse data, response status code and response headers
    def remove_with_http_info(container_container_repository_href, recursive_manage, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: RepositoriesContainerApi.remove ...'
      end
      # verify the required parameter 'container_container_repository_href' is set
      if @api_client.config.client_side_validation && container_container_repository_href.nil?
        fail ArgumentError, "Missing the required parameter 'container_container_repository_href' when calling RepositoriesContainerApi.remove"
      end
      # verify the required parameter 'recursive_manage' is set
      if @api_client.config.client_side_validation && recursive_manage.nil?
        fail ArgumentError, "Missing the required parameter 'recursive_manage' when calling RepositoriesContainerApi.remove"
      end
      # resource path
      local_var_path = '{container_container_repository_href}remove/'.sub('{' + 'container_container_repository_href' + '}', CGI.escape(container_container_repository_href.to_s).gsub('%2F', '/'))

      # query parameters
      query_params = opts[:query_params] || {}

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json', 'application/x-www-form-urlencoded', 'multipart/form-data'])

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:body] || @api_client.object_to_http_body(recursive_manage) 

      # return_type
      return_type = opts[:return_type] || 'AsyncOperationResponse' 

      # auth_names
      auth_names = opts[:auth_names] || ['basicAuth']

      new_options = opts.merge(
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:POST, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: RepositoriesContainerApi#remove\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # Sync from a remote
    # Trigger an asynchronous task to sync content.
    # @param container_container_repository_href [String] 
    # @param repository_sync_url [RepositorySyncURL] 
    # @param [Hash] opts the optional parameters
    # @return [AsyncOperationResponse]
    def sync(container_container_repository_href, repository_sync_url, opts = {})
      data, _status_code, _headers = sync_with_http_info(container_container_repository_href, repository_sync_url, opts)
      data
    end

    # Sync from a remote
    # Trigger an asynchronous task to sync content.
    # @param container_container_repository_href [String] 
    # @param repository_sync_url [RepositorySyncURL] 
    # @param [Hash] opts the optional parameters
    # @return [Array<(AsyncOperationResponse, Integer, Hash)>] AsyncOperationResponse data, response status code and response headers
    def sync_with_http_info(container_container_repository_href, repository_sync_url, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: RepositoriesContainerApi.sync ...'
      end
      # verify the required parameter 'container_container_repository_href' is set
      if @api_client.config.client_side_validation && container_container_repository_href.nil?
        fail ArgumentError, "Missing the required parameter 'container_container_repository_href' when calling RepositoriesContainerApi.sync"
      end
      # verify the required parameter 'repository_sync_url' is set
      if @api_client.config.client_side_validation && repository_sync_url.nil?
        fail ArgumentError, "Missing the required parameter 'repository_sync_url' when calling RepositoriesContainerApi.sync"
      end
      # resource path
      local_var_path = '{container_container_repository_href}sync/'.sub('{' + 'container_container_repository_href' + '}', CGI.escape(container_container_repository_href.to_s).gsub('%2F', '/'))

      # query parameters
      query_params = opts[:query_params] || {}

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json', 'application/x-www-form-urlencoded', 'multipart/form-data'])

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:body] || @api_client.object_to_http_body(repository_sync_url) 

      # return_type
      return_type = opts[:return_type] || 'AsyncOperationResponse' 

      # auth_names
      auth_names = opts[:auth_names] || ['basicAuth']

      new_options = opts.merge(
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:POST, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: RepositoriesContainerApi#sync\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # Create a Tag
    # Trigger an asynchronous task to tag an image in the repository
    # @param container_container_repository_href [String] 
    # @param tag_image [TagImage] 
    # @param [Hash] opts the optional parameters
    # @return [AsyncOperationResponse]
    def tag(container_container_repository_href, tag_image, opts = {})
      data, _status_code, _headers = tag_with_http_info(container_container_repository_href, tag_image, opts)
      data
    end

    # Create a Tag
    # Trigger an asynchronous task to tag an image in the repository
    # @param container_container_repository_href [String] 
    # @param tag_image [TagImage] 
    # @param [Hash] opts the optional parameters
    # @return [Array<(AsyncOperationResponse, Integer, Hash)>] AsyncOperationResponse data, response status code and response headers
    def tag_with_http_info(container_container_repository_href, tag_image, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: RepositoriesContainerApi.tag ...'
      end
      # verify the required parameter 'container_container_repository_href' is set
      if @api_client.config.client_side_validation && container_container_repository_href.nil?
        fail ArgumentError, "Missing the required parameter 'container_container_repository_href' when calling RepositoriesContainerApi.tag"
      end
      # verify the required parameter 'tag_image' is set
      if @api_client.config.client_side_validation && tag_image.nil?
        fail ArgumentError, "Missing the required parameter 'tag_image' when calling RepositoriesContainerApi.tag"
      end
      # resource path
      local_var_path = '{container_container_repository_href}tag/'.sub('{' + 'container_container_repository_href' + '}', CGI.escape(container_container_repository_href.to_s).gsub('%2F', '/'))

      # query parameters
      query_params = opts[:query_params] || {}

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json', 'application/x-www-form-urlencoded', 'multipart/form-data'])

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:body] || @api_client.object_to_http_body(tag_image) 

      # return_type
      return_type = opts[:return_type] || 'AsyncOperationResponse' 

      # auth_names
      auth_names = opts[:auth_names] || ['basicAuth']

      new_options = opts.merge(
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:POST, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: RepositoriesContainerApi#tag\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # Delete a tag
    # Trigger an asynchronous task to untag an image in the repository
    # @param container_container_repository_href [String] 
    # @param un_tag_image [UnTagImage] 
    # @param [Hash] opts the optional parameters
    # @return [AsyncOperationResponse]
    def untag(container_container_repository_href, un_tag_image, opts = {})
      data, _status_code, _headers = untag_with_http_info(container_container_repository_href, un_tag_image, opts)
      data
    end

    # Delete a tag
    # Trigger an asynchronous task to untag an image in the repository
    # @param container_container_repository_href [String] 
    # @param un_tag_image [UnTagImage] 
    # @param [Hash] opts the optional parameters
    # @return [Array<(AsyncOperationResponse, Integer, Hash)>] AsyncOperationResponse data, response status code and response headers
    def untag_with_http_info(container_container_repository_href, un_tag_image, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: RepositoriesContainerApi.untag ...'
      end
      # verify the required parameter 'container_container_repository_href' is set
      if @api_client.config.client_side_validation && container_container_repository_href.nil?
        fail ArgumentError, "Missing the required parameter 'container_container_repository_href' when calling RepositoriesContainerApi.untag"
      end
      # verify the required parameter 'un_tag_image' is set
      if @api_client.config.client_side_validation && un_tag_image.nil?
        fail ArgumentError, "Missing the required parameter 'un_tag_image' when calling RepositoriesContainerApi.untag"
      end
      # resource path
      local_var_path = '{container_container_repository_href}untag/'.sub('{' + 'container_container_repository_href' + '}', CGI.escape(container_container_repository_href.to_s).gsub('%2F', '/'))

      # query parameters
      query_params = opts[:query_params] || {}

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json', 'application/x-www-form-urlencoded', 'multipart/form-data'])

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:body] || @api_client.object_to_http_body(un_tag_image) 

      # return_type
      return_type = opts[:return_type] || 'AsyncOperationResponse' 

      # auth_names
      auth_names = opts[:auth_names] || ['basicAuth']

      new_options = opts.merge(
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:POST, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: RepositoriesContainerApi#untag\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end

    # Update a container repository
    # Trigger an asynchronous update task
    # @param container_container_repository_href [String] 
    # @param container_container_repository [ContainerContainerRepository] 
    # @param [Hash] opts the optional parameters
    # @return [AsyncOperationResponse]
    def update(container_container_repository_href, container_container_repository, opts = {})
      data, _status_code, _headers = update_with_http_info(container_container_repository_href, container_container_repository, opts)
      data
    end

    # Update a container repository
    # Trigger an asynchronous update task
    # @param container_container_repository_href [String] 
    # @param container_container_repository [ContainerContainerRepository] 
    # @param [Hash] opts the optional parameters
    # @return [Array<(AsyncOperationResponse, Integer, Hash)>] AsyncOperationResponse data, response status code and response headers
    def update_with_http_info(container_container_repository_href, container_container_repository, opts = {})
      if @api_client.config.debugging
        @api_client.config.logger.debug 'Calling API: RepositoriesContainerApi.update ...'
      end
      # verify the required parameter 'container_container_repository_href' is set
      if @api_client.config.client_side_validation && container_container_repository_href.nil?
        fail ArgumentError, "Missing the required parameter 'container_container_repository_href' when calling RepositoriesContainerApi.update"
      end
      # verify the required parameter 'container_container_repository' is set
      if @api_client.config.client_side_validation && container_container_repository.nil?
        fail ArgumentError, "Missing the required parameter 'container_container_repository' when calling RepositoriesContainerApi.update"
      end
      # resource path
      local_var_path = '{container_container_repository_href}'.sub('{' + 'container_container_repository_href' + '}', CGI.escape(container_container_repository_href.to_s).gsub('%2F', '/'))

      # query parameters
      query_params = opts[:query_params] || {}

      # header parameters
      header_params = opts[:header_params] || {}
      # HTTP header 'Accept' (if needed)
      header_params['Accept'] = @api_client.select_header_accept(['application/json'])
      # HTTP header 'Content-Type'
      header_params['Content-Type'] = @api_client.select_header_content_type(['application/json', 'application/x-www-form-urlencoded', 'multipart/form-data'])

      # form parameters
      form_params = opts[:form_params] || {}

      # http body (model)
      post_body = opts[:body] || @api_client.object_to_http_body(container_container_repository) 

      # return_type
      return_type = opts[:return_type] || 'AsyncOperationResponse' 

      # auth_names
      auth_names = opts[:auth_names] || ['basicAuth']

      new_options = opts.merge(
        :header_params => header_params,
        :query_params => query_params,
        :form_params => form_params,
        :body => post_body,
        :auth_names => auth_names,
        :return_type => return_type
      )

      data, status_code, headers = @api_client.call_api(:PUT, local_var_path, new_options)
      if @api_client.config.debugging
        @api_client.config.logger.debug "API called: RepositoriesContainerApi#update\nData: #{data.inspect}\nStatus code: #{status_code}\nHeaders: #{headers}"
      end
      return data, status_code, headers
    end
  end
end
